package org.amse.asves.skinCreator.view;


import org.amse.asves.skinCreator.model.Options;
import org.amse.asves.skinCreator.model.Rectangle;

/**
 *  preview
 *  ,     
 * @author 
 *
 */
/*
 * TODO   !!!
 * TODO         SkinViewer
 */
public final class PreviewManager {
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return true      
	 *    
	 */
	public static boolean isClickedOnPlaylistTitleBar(int x, int y){
		return ((x >= Options.PREVIEW_BAR_X) && 
				(x < 528 + 0 + Options.PREVIEW_BAR_X) && 
				(y > 232 + Options.PREVIEW_BAR_Y) && 
				(y <= 14 + 232 + Options.PREVIEW_BAR_Y));
	}
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return true      
	 *      ( )
	 */
	public static boolean isClickedOnPlaylistButton(int x, int y){
		return ((x >= 528 + Options.PREVIEW_BAR_X) && 
				(x < 550 + 0 + Options.PREVIEW_BAR_X) && 
				(y > 232 + Options.PREVIEW_BAR_Y) && 
				(y <= 14 + 232 + Options.PREVIEW_BAR_Y));
	}
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return true      
	 *    
	 */
	public static boolean isClickedOnEqualizerTitleBar(int x, int y){
		return ((x >= Options.PREVIEW_BAR_X) && 
				(x < 252 + Options.PREVIEW_BAR_X) && 
				(y > 115 + Options.PREVIEW_BAR_Y) && 
				(y <= 129 + Options.PREVIEW_BAR_Y));
	}
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return true      
	 *      ( )
	 */
	public static boolean isClickedOnEqualizerButton(int x, int y){
		return ((x >= 252 + Options.PREVIEW_BAR_X) && 
				(x < 275 + Options.PREVIEW_BAR_X) && 
				(y > 115 + Options.PREVIEW_BAR_Y) && 
				(y <= 129 + Options.PREVIEW_BAR_Y));
	}
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return       
	 *         
	 */
	public static int getSongTitleByClick(int x, int y){
		//134 257
		if ((y > 256 + Options.PREVIEW_BAR_Y) && (y < 424 + Options.PREVIEW_BAR_Y) && 
			(x < 530 + Options.PREVIEW_BAR_X) && (x > 10 + Options.PREVIEW_BAR_X)){
			return ((y - 255 - Options.PREVIEW_BAR_Y)) / 12 + 1;
		}
		return -1;
	}
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return       
	 *         
	 */
	public static int getSelectedSongTitleByClick(int x, int y){
		//134 257
		if ((y > 256 + Options.PREVIEW_BAR_Y) && (y < 424 + Options.PREVIEW_BAR_Y) && 
			(x > 10 + Options.PREVIEW_BAR_X) && (x < 530 + Options.PREVIEW_BAR_X)){
			return ((y - 255 - Options.PREVIEW_BAR_Y)) / 12 + 1;
		}
		return -1;
	}
	
	/**
	 * @param n -     
	 * @return       
	 *    
	 */
	public static Rectangle getColorRect(int n){
		int x = Options.SETTINGS_FRAME_X + Options.SETTINGS_FRAME_THICKNESS*2 + 350;
		int y = (n+1)*(Options.SETTINGS_FONT_SIZE + 3) + Options.SETTINGS_FRAME_Y + Options.SETTINGS_FRAME_THICKNESS - 5;
		return new Rectangle(x, y, x + Options.COLOR_BAR_WIDTH, y + Options.COLOR_BAR_HEIGHT);
	}
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return true      
	 *    
	 */
	public static boolean isClickedOnPlaylistShade(int x, int y){
		return ((x >= 0 + Options.PREVIEW_BAR_X) && 
				(x < 0 + 530 + Options.PREVIEW_BAR_X) && 
				(y > 600 + Options.PREVIEW_BAR_Y) && 
				(y <= 600 + 13 + Options.PREVIEW_BAR_Y));
	}
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return true      
	 *    
	 */
	public static boolean isClickedOnEqualizerShade(int x, int y){
		//439
		return ((x >= 185 + Options.PREVIEW_BAR_X) && 
				(x < 439 + Options.PREVIEW_BAR_X) && 
				(y > Options.SHADE_PREVIEW_Y - 50 + Options.PREVIEW_BAR_Y) && 
				(y <= 564 + Options.PREVIEW_BAR_Y));
	}
	
	/**
	 * @param x -  
	 * @param y -  
	 * @return true      
	 *    
	 */
	public static boolean isClickedOnEqualizerShadeButton(int x, int y){
		//439
		return ((x >= 439 + Options.PREVIEW_BAR_X) && 
				(x < 460 + Options.PREVIEW_BAR_X) && 
				(y > Options.SHADE_PREVIEW_Y - 50 + Options.PREVIEW_BAR_Y) && 
				(y <= 564 + Options.PREVIEW_BAR_Y));
	}
	
	/**
	 * @return true  @param rect -   
	 *    shade mode (-)   
	 */
	public static boolean rectIsEQShadeButtonInshade(Rectangle rect){
		return rect.contains(440,560) && (rect.area() < 100);
	}
}
