package org.amse.asves.skinCreator.model;

import java.util.HashMap;
/**
 *   
 *    
 * @author 
 *
 */
public enum ContainerName {
	/**
	 *  .
	 * 1.   avs
	 *   .     
	 *         
	 *       
	 *   gen    gen_ex
	 * 2.         
	 *    2.9.      
	 */
	//AVS("avs", false),
	BALANCE("balance"),
	CBUTTONS("cbuttons"),
	EQ_EX("eq_ex"),
	EQMAIN("eqmain"),
	GEN("gen"),
	GENEX("genex"),
	MAIN("main"),
	MB("mb"),
	MONOSTER("monoster"),
	NUMS_EX("nums_ex"),
	NUMBERS("numbers"),
	PLAYPAUS("playpaus"),
	PLEDIT("pledit"),
	POSBAR("posbar"),
	SHUFREP("shufrep"),
	TEXT("text"),
	TITLEBAR("titlebar"),
	VIDEO("video"),
	VOLUME("volume"),

	VIS(""),
	ARROW("");
	
	private final String myFileName;
	
	private ContainerName(String fileName) {
		myFileName = fileName + ".bmp";
	}
	
	private static HashMap<ContainerName, ContainerName> 
		myEmergencyContainers = new HashMap<ContainerName, ContainerName>();
	
	/**
	 *     
	 *    
	 * @param containers
	 */
	private static void addEmergencyContainers(ContainerName ... containers){
		for (int i = 0; i < containers.length - 1; i++)
			myEmergencyContainers.put(containers[i], containers[i + 1]);
		
	}
	
	static {
		addEmergencyContainers(NUMS_EX, NUMBERS);
	}	
	
	/**
	 *        
	 *      -   nums_ex.bmp
	 *   numbers.bmp
	 *     -     2.9
	 *          
	 * @return
	 */
	public ContainerName getEmergencyContainer(){
		if (myEmergencyContainers.get(this) != null){
			return myEmergencyContainers.get(this);
		}else{
			return this;
		}
			
	}
	
	/**
	 * @return      
	 * -   
	 *           
	 *       
	 */
	public String getFileNameU(){
		return myFileName.toUpperCase();
	}
}
