package org.amse.asves.skinCreator.model;

import org.amse.asves.skinCreator.exceptions.InvalidFile;

/**
 *   - 
 *         
 *  -- buffered image  ,
 *      
 * @author 
 *
 */
public interface ISkin {
	
	/**
	 *  .
	 *      -    
	 *   . 
	 *          
	 *  widget,         
	 * -
	 */
	public void initialize() throws InvalidFile;
	
	/**
	 * @return     @param name 
	 */
	public IWidget getWidget(WidgetName name);
	
	/**
	 *	@return    viscolor.txt    @param number
	 */
	public RGBColor getViscolorColor(int number);
	
	/**
	 *	        @param number 
	 *	  viscolor.txt   @param color
	 */
	public void setViscolorColor(int number, RGBColor color);
	
	/**
	 *	        @param name 
	 *	  pledit.txt   @param color
	 */
	public void setPleditColor(PleditParameterName name, RGBColor color);
	
	/**
	 *	@return    pledit.txt    @param name
	 */
	public RGBColor getPleditColor(PleditParameterName name);
	
	/**
	 * @return    .      
	 */
	public RGBColor getScrollBGColor();
	
	/**
	 *      
	 * @param color
	 */
	public void setScrollBGColor(RGBColor color);
	public void setScrollTextColor(RGBColor color);
	
	/**
	 *     pledit.txt    
	 *   .
	 * @return 
	 */
	public String getFont();
	
	/**
	 *   
	 * @param s
	 */
	public void setFont(String s);

}
