package org.amse.asves.skinCreator.wsz;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 *  
 *       
 *    ".zip"  ".wsz"
 * @author 
 *
 */
public class SkinFileFilter extends FileFilter {

	@Override
	public boolean accept(File arg0) {
		if (arg0.isDirectory()) return true;
		
		String name = arg0.getName();
		int length = name.length();
		if (length > 4) {
			String shortName = name.substring(length-4,length);
			//System.out.println(shortName);
			return (shortName.toUpperCase().equals(".WSZ")) ||
					(shortName.toUpperCase().equals(".ZIP"));
		}else{
			return false;
		}
	}

	@Override
	public String getDescription() {
		return "Skin File (*.wsz, *.zip)";
	}

}
